class DbmonMaster : public RtMaster {
	char	*kbd(char*);
	char	*help(long);
	void	refresh();
	virtual char *proctype() = 0;
	void	open();
public:
	DbmonMaster(int f,int i,int p,RtNode* n): RtMaster(f, i, p, n) {}
	void	clean(Process*);
};

class DbmonProcess : public Process {
	friend	DbmonCore;
protected:
	int	fd;
	int	boardid;
	int	pipeid;
	int	accept(Action);
	Index	carte();
	void	hang();
	void	hangopen();
	void	hangtakeover();
	void	substitute(DbmonProcess*);
	void	takeover();
	void	destroy();
	virtual Core *newCore(int,int,int,Master*) = 0;
public:
		DbmonProcess(int,int,int,Process*,char*,char*,char*);
	void	open();
};

class DbmonCore : virtual public Core {
	friend DbmonProcess;
protected:
	int		fd;
	int		boardid;
	int		pipeid;
	DebugAttrib	attrib;
	DebugKstate	state;
	long		scratch;
	int		running;
	int		regsize;
	Behavs	behavetype();
	char	*dbreq(int, char* =0, int =0, int =0);
	char	*dostep(long,long,int);
	char	*readwrite(long,char*,int,int);
	long	regaddr();
	long	scratchaddr();
	virtual	char *faultname(int);
public:
		DbmonCore(int,int,int);
	Behavs	behavs();
	char	*destroy();
	char	*eventname();
	char	*laybpt(Trap*);
	char	*open();
	char	*problem();
	char	*readcontrol();
	char	*reopen(char*,char*);
	char	*run();
	char	*stop();
};
