.H 1 "Processor Dependencies"
This section describes the processor dependencies such as register names.
There is a separate section for each processor.
.H 2 "SPARC"
The SPARC architecture is used in Sun's SPARCstations and Sun4 family of
workstations and is supported in SPARC pi.
The registers are named:
.DS I F
$g0-$g7, $o0-$o5, $sp, $o7, $l0-$l7,
$i0-$i5, $fp, $i7, $psr, $pc, $npc, and $y.
.DE
.P
The values of
$o0-$o5, $sp, $o7, $l0-$l7, $i0-$i5, $fp, and $i7
are extracted from their saved locations on the stack and vary
in different Frame windows.
The other registers display the same value in all Frame windows.
The value of $g0 is always 0.
.H 2 "MIPS R3000"
The MIPS Computer Systems R3000 and R4000 processors are used in Silicon
Graphics (SGI) workstations and are supported in SGI pi.
The register names use the MIPS software conventions:
.DS I F
$zero, $at, $v0, $v1, $a0-$a3, $t0-$t7, $s0-$s7, $t8, $t9, $k0, $k1,
$gp, $sp, $s8, $ra, $pc, $cause, $badvaddr, $mmhi, $mmlo, $fpcpcsr, and $fpceir.
.DE
.P
The values of
$s0-$s7 and $ra
are extracted from their saved locations on the stack and vary
in different Frame windows.
The other registers display the same value in all Frame windows.
The value of $zero is always 0.
.H 2 "MC680X0"
Members of the Motorola MC680X0 family of processors are supported in Sun-3 pi.
The registers are named:
.DS I F
$d0-$d7, $a0-$a5, $fp, $sp, $ps and $pc.
.DE
.P
The values of
$d2-$d7 and $a2-$a5
are extracted from their saved locations on the stack and vary
in different Frame windows.
The other registers display the same value in all Frame windows.
.H 2 "PCs"
The PC version of pi and rtpi's Remote Unix Pi window
support 80[34]86 based personal computers running Unix SysV R3.2.[23].
The registers are named:
.DS I F
$eax, $ecx, $edx, $ebx, $esp, $ebp, $esi, $edi, $eip, $eflags, $ds,
$es, $fs, $gs, $ss, $cs, $trapno, $error, and $kesp.
.DE
.P
The values of
$ebx, $esi, and $edi
are extracted from their saved locations on the stack and vary
in different Frame windows.
The other registers display the same value in all Frame windows.
