.H 1 "Directory Window"
This window displays and changes the working directory of the debugger.
The working directory determines where the debugger looks when trying to
open files that have relative path names.
It affects where executable files containing the symbol tables,
core dumps, and source code files for processes that have not specified a
directory search path in their Source Files window are found.
The window is opened by selecting the "pwd/cd" entry in the Keyboard
Input window's "windows" menu.
.H 2 "Directory Layout"
Each line in the Directory window displays the full path
name of a directory, and is the output of the command "/bin/pwd".
The last line in the window starts with the characters "wd=" and displays
the debugger's current working directory.
When the working directory is changed from the keyboard or menus,
a line listing the new working directory is appended
after the last line in the window, and the previous working directory
becomes the next to last line.
The window keeps an ordered history of the directories that have been visited.
.P
If an error occurs while attempting to change directories the message:
.DS I N
cannot cd directory
.DE
.P
is inserted into the window.
.H 2 "Directory Menu Bar"
The "chdir" menu is the line menu for the line displaying the working directory.
See "Directory Line Menus".
.H 2 "Directory Keyboard"
Syntax
.DS I N
 [cd] [directory]
.DE
.P
The window's keyboard language allows you to change the working directory
of the debugger by typing in a new directory name.
The directory may be a full path name, or a path name relative to
the current directory.
The optional "cd" is provided for compatibility with the command
used to change directories in most shells.
If the directory field is missing,
the debugger changes to the directory in the environment variable HOME.
.H 2 "Directory Line Menus"
Each line menu lists the subdirectories of the directory displayed on the line.
Selecting an entry makes that directory the working directory.
Each menu also has "." and ".." entries to allow you to move to
to the directory displayed on the line or its parent directory. 
